<?
require_once('sonos.class.php');
require_once('sonos.ips.defines.php');
include_once('sonos.ips.config.inc');
if(!function_exists('Debug')){function Debug($data){if($_IPS['SENDER']=='Execute')echo $data.PHP_EOL;else IPS_LogMessage('SONOS_LOG:',$data);}}
class IPSSonosPlayer extends SonosUpnpDevice {
	private $INSTANCE_ID=0;
	
	public function __construct($data){
		$id=0;
		if(is_numeric($data)){
			$id=$data;
			$data=GetValue(IPS_GetObjectIdByIdent(SONOS_ident_host,$data));
		}
		parent::__construct($data);
		$this->INSTANCE_ID=$id;
	}
	
	public function getZonePlayerList(){
		
		if(!$xml=$this->deviceCmdRaw('/status/topology')){
			return false;
		}	
		$topology = simplexml_load_string($xml);
		$myself = null;
		$coordinators = [];
		// Loop players, build map of coordinators and find myself
		foreach ($topology->ZonePlayers->ZonePlayer as $player)	{
			$player_data = $player->attributes();
			$name=utf8_decode((string)$player);
			$group=explode('RINCON_',(string)$player_data->group)[1];

			$ip = parse_url((string)$player_data->location)['host'];
			$port = parse_url((string)$player_data->location)['port'];
			if($ip==$this->_IP){
				$info=$this->GetZoneAttributes();
			} else {
				$p=new self($ip,$port);
				$info=$p->GetZoneAttributes();
				$p=null;
			}
			$player = array(
				'host'=>"$ip:$port",
				'name'=>$name,
				'icon'=>$info['CurrentIcon'],
				'master'=>((string)$player_data->coordinator == 'true'),
				'ident'=>explode('RINCON_',(string)$player_data->uuid)[1]
			);
			$coordinators[$group][] = $player;
		}
		function cmp($a, $b) {
			if ($a['master'] == $b['master']) {
				if($a['name'] == $b['name']) 
					return 0;
				else 
					return ($a['name'] > $b['name']) ? 1 : -1;;
			}
			return ($a['master'] === TRUE) ? -1 : 1;
		}
		foreach ($coordinators as $key=>$coordinator){
			usort($coordinators[$key], "cmp");
		}
		return $coordinators;
	}
	

	
	public function RegisterEvents(){
		$callbackUrl=GetValue(VAR_CallbackUrlId);
		$SID_Id=IPS_GetObjectIdByIdent('SID',$this->INSTANCE_ID);
		if(!$callbackUrl){
			Debug ("Kein Callback Host Konfiguriert\nDer Eintrag lautet: http://ip-deines-ipsymcon-servers:".IPS_GetProperty(VAR_ServerInstanceId,'Port')."\n !ACHTUNG!!!  Gleich vorab .... localhost geht nicht *g* da deine Media-Gerte damit nichts anfangen knnen");
			return false;
		}
		$SIDS=unserialize(GetValue($SID_Id));
		if(is_array($SIDS)&&(count($SIDS)>0)){
			echo "Events bereits Registriert";
			return true;
		}
		$callbackTime=GetValue(VAR_CallbackTimeId);
		if((!$callbackTime)||($callbackTime<60))$callbackTime=300;
		$r=$this->CallService('AVTransport','RegisterEventCallback',array($callbackUrl,$callbackTime));
		$SIDS=[];
		if($r && IsSet($r['SID'])){
			$SID=trim($r['SID']);
			$SIDS['AVTransport']=$SID;
			include_once ('sonos.ips.splitter.class.php');
			IPSSonos_SplitterAddClient($this->INSTANCE_ID,$SID);
		}
		SetValue($SID_Id ,serialize($SIDS));
	}

	public function UnRegisterEvents(){
		$SID_Id=IPS_GetObjectIdByIdent('SID',$this->INSTANCE_ID);
		$SIDS=unserialize(GetValue($SID_Id));
		if($SIDS){
			foreach($SIDS as $serviveName=>$SID){
				if($SID){
					try {
						$SIDS[$serviveName]='';
						$this->CallService($serviveName,'UnRegisterEventCallback',array($SID));
					} catch (Exception $e) {}
				}
			}
		} 
		$NEWSIDS=[];if($SIDS)foreach($SIDS as $k=>$v)if($v)$NEWSIDS[$k]=$v;
		if(count($NEWSIDS)>0){
			SetValue($SID_Id ,serialize($NEWSIDS));
			return false;
		}else {
			include_once ('sonos.ips.splitter.class.php');
			IPSSonos_SplitterRemoveClient($this->INSTANCE_ID);
			SetValue($SID_Id ,'');
		}
		return true;
	}

	protected function deviceCmdRaw($url, $ip='', $port=0) {
		if(!$ip)$ip=$this->_IP;
		if(!$port)$port=$this->_PORT;
		$url = "http://{$ip}:{$port}{$url}";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$data = curl_exec($ch);
		curl_close($ch);
		return $data;
	}
}	
	
?>
